<?php
setlocale(LC_TIME, 'C');

foreach ( $_POST as $k => $v ) {
	if ( $k != 'login' ) {
		unset($_POST[$k]); unset($_REQUEST[$k]);
	}
}
foreach ( $_GET as $k => $v )  {
	if ( $k != 'out' && $k != 'in' && $k != 're' ) {
		unset($_GET[$k]);  unset($_REQUEST[$k]);
	}
}

$key = 'ahQuie2o';

session_start();
#error_reporting(E_ALL);
require_once('../tiki-setup.php');
if ( $prefs['mods_dir'] != '' ) $prefs['mods_dir'] = 'mods';
include('lib/mods/modslib.php');
require_once('functions.php');

$admin = $login = false;
$public = false;

$_REQ= array();
for ( $k = 1 ; $k < $_SERVER['argc'] ; $k++ ) {
	list($keys, $value) = explode('=', $_SERVER['argv'][$k], 2);
	$_REQ[$keys] = $value ? $value : 'y';
}

if ( ! empty($_REQ["re"]) && ! empty($_REQ["login"]) && $_REQ["login"] == $key ) {
	$_GET['re'] = $_REQ['re'];
	$_SESSION['admin'] = true;
}

if (isset($_SESSION['admin']) and $_SESSION['admin'] == true) {
	if (isset($_GET['out'])) {
		$_SESSION['admin'] = false;
	} else {
		$admin = true;
		if (isset($_GET['re']) == 'y' ) {
			$modslib->rebuild_list($prefs['mods_dir'].'/Packages');
			$public = $modslib->read_list($prefs['mods_dir'].'/Packages/00_list.txt', false);
			if ( is_array($public) ) {
				foreach ( $public as $type => $p2 ) {
					if ( is_array( $p2 ) ) {
						foreach ( $p2 as $modname => $p3 ) {
							$items[] = $type.'-'.$modname;
						}
					}
				}
			}
			$modslib->_publish($prefs['mods_dir'], array(), $items, true);
		}
	}
} else {
	if (isset($_GET['in'])) {
		$login = true;
	} elseif (isset($_POST['login']) and $_POST['login'] == $key) {
		$_SESSION['admin'] = true;
		$admin = true;
	}
}
if ( ! $public ) $public = $modslib->read_list($prefs['mods_dir'].'/Packages/00_list.public.txt', false);
$dist = $modslib->scan_dist($prefs['mods_dir'].'/Dist');

echo '<?xml version="1.0" encoding="UTF-8"?>';
?>
<!DOCTYPE html> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>TikiMods</title>
<link href="favicon.png" rel="icon">
<style type="text/css"><!--
body { margin : 0; }
a { text-decoration : none; }
a:hover { background-color : #FF0; }
h1 { padding : 50px 140px; margin : 0 0 5px 0; font-size :38px !important; color: white; font-family: Paneuropa,"Bitstream Vera Sans",Arial,Helvetica,sans-serif; }
h2 { padding : 0; margin : 0; }
td { font-size : 90%; vertical-align : top; border-bottom : 1px dashed #bbb; max-width: 600px; }
input { border : 0; }
.item { background-color : #FFF; }
.item:hover { background-color : #FF8; }
.intro { margin : 10px; }
.meat { margin : 0 10px;  }
.d_recent { color : #c03; background-color : #FC8; }
.d_fresh { color : #960; background-color : #FF8; }
.d_current { color : #393; background-color : #cfc; }
.d_old { color : #58b; background-color : #def; }
.d_veryold { color : #888; background-color : #eee; }
.link { color : #246; font-weight : bold; padding : 0 20px; }
.admin { background-color : #ddd; color : #fff; font-weight : bold; padding : 1px 5px; }
.admin:hover { color : #000; }
header { height: 215px; background: url("siteheadertile.jpg") no-repeat scroll 900px 0 transparent;}
div.fixedwidth { width: 990px; margin: 0 auto;background: url("./siteheader.png") no-repeat scroll -250px 0 transparent; display: table; height: 170px;}
.floatleft { float: left;}
#tiki-top, #tiki-bottom {height: 50px; background: black;display: block;}
#logo {padding-top: 15px;}
--></style>
</head>
<body>
<header>
<div class="fixedwidth">
<img class="floatleft" id="logo" src="Tiki_WCG.png" />
<h1 class="floatleft">Mods Repository</a></h1>
</div>
<div id="tiki-top"></div>
</header>
<div class="intro">
<div style="float:left;padding:3px;border:1px solid #bbb;font-size:90%;margin-right:10px;">
<div class="d_recent">&nbsp;Red : recent &lt; 1 week</div>
<div class="d_fresh">&nbsp;Orange : fresh &lt; 1 month</div>
<div class="d_current">&nbsp;Green : current &lt; 3 month</div>
<div class="d_old">&nbsp;Blue : old &gt; 3 months</div>
<div class="d_veryold">&nbsp;Grey : archive &gt; 1 year</div>
</div>
This public repository lists the mods packages available from tiki.org server. It's used by tiki admins to update features that are not included in the public release of
Tiki Wiki CMS Groupware. see <a href="http://tiki.org/TikiMods">TikiMods</a> page on tw.o<br /><br />
<?php if ($admin) { ?>
<a href="index.php?re" class="admin">Rebuild</a>
<a href="index.php?out" class="admin">Get out</a>
<?php } elseif ($login) { ?>
<form method="post" action="index.php" name="f"><input type="password" name="login" value="" /></form>
<?php } ?>
</div>
<br clear="all" />
<table class="meat">
<tr><td>Type</td><td>Dl</td><td>Name</td><td>LastUpdate</td><td>Version</td><td>Licence</td><td>Description</td></tr>
<?
//$lastup = file('.lastup');
//echo "<div>Last CVS update: ". date('l j F, Y [H:i]',trim($lastup[0])).'</div>';

$svn_data_file = $prefs['mods_dir'].'/Packages/list.xml'; // File generated by the subversion command: svn list --xml
$mods_svn_info = mods_svn_info($svn_data_file);
$date_format = '%Y.%m.%d';
foreach ($public as $type=>$list) {
	$nb_items = count($list);
	if ( $type == "themes" )
		$nb_items = $nb_items - 1;
	echo "<tr class='bloc'>\n";
	echo "<td rowspan='$nb_items'><h2>$type</h2></td>\n";

	foreach ($list as $mod=>$data) {
		if (is_object($data) && isset($dist[$data->modname])) {
			$tarname = $data->modname.'-'.$data->revision.'.tgz';
			$date = $mods_svn_info[$data->modname]['date'];
			echo "<td><a href='Dist/$tarname' class='date $cl'><img alt='Download Tarball' src='gz.png' width='16' height='16' border='0' /></a></td>\n";
			echo "<td class='itemtitle'>";
			echo "<a href='details.php?type=". urlencode($type)."&amp;mod=". urlencode($mod)."' class='link'>$mod</a></td>";
			if (is_file($prefs['mods_dir'].'/Dist/'.$tarname)) {
				$diff = (date('U') - $date) / (60*60*24);
				if ($diff < 7) {
					$cl = "d_recent";
				} elseif ($diff < 30) {
					$cl = "d_fresh";
				} elseif ($diff < 90) {
					$cl = "d_current";
				} elseif ($diff < 365) {
					$cl = "d_old";
				} else {
					$cl = "d_veryold";
				}
				echo "<td><a href='Dist/$tarname' class='date $cl'>".strftime($date_format, $date)."</a></td>\n";
			}
			echo "<td>".$data->revision."</td>";
			echo "<td>".$data->licence."</td>\n";
			echo "<td>".$data->description."</td>\n";
			if ( --$nb_items > 0 ) echo "</tr>\n<tr class='item'>";
		}
	}
	echo "</tr>\n";
}
?>
</table>
<div id="tiki-bottom"></div>
</body>
</html>
